/*
 * pwm.h
 *
 *  Created on: 2014-1-20
 *      Author: a0220211
 */

#ifndef PWM_H_
#define PWM_H_

#include "het.h"
#include "pwm_drv.h"

#define	vCNT_MAX 				249
#define HALF_PERIOD				(125<<7)
#define PWM_BASE_ADDR			3					// PWM control base index
#define HET_INT_ADDR			15					// HET interrupt instruction index

#define HET_FREQUENCY			90					// HET module clock
#define HET_HR					1					// HR resolution
#define HET_LR					32					// LR resolution
#define HET_LR_REG				5					// LR resolution register setting
#define ISR_FREQUENCY 			(1000*HET_FREQUENCY/(HET_HR*HET_LR*(vCNT_MAX+1)))	// HET interrupt frequency
#define BASE_FREQ      			120													// Sine wave base frequency
#define T 						(0.001/ISR_FREQUENCY)								// parameter

void het_int_enable(void);
void het_int_disable(void);
void het_pwm_update(float Ta, float Tb, float Tc, int deadzone);

#endif /* PWM_H_ */
