/* ==================================================================================
File name:		PWM_DRV.C
                    
Originator:		TMS470 / TMS570 Application Group - Texas Instruments

Description: 	This file contains source for the Full Compare PWM  drivers for 
			 	the TMS570R4x (NHET)
			 	
Target: 		TMS570R4x family

=====================================================================================
History:
-------------------------------------------------------------------------------------
Date		|	Version	|	Author		|	Description	
03.01.2007	|	1.0		|	AEC			|	Original: int (fixed point), pu
----------------------------------------------------------------------------------*/
//FOC SW module
#include "pwm_drv.h"

void PWM_Update(PWMGEN *p)								//try to declare this as a macro function// 
{       
	short MPeriod;
    int Tmp;
		
    MPeriod = p->PeriodMax>>1; 							//try to write these three calculations in one single array//

// Compute the compare 1 (Q0) from the PWM 1&2 duty cycle ratio (Q15)
	Tmp = (int)MPeriod*(int)p->MfuncC1;               	// Q15 = Q0*Q15
	p->CMPA1 = (short)(Tmp>>16) + (short)(MPeriod>>1);	// Q0 = (Q15->Q0)/2 + (Q0/2)

// Compute the compare 3 (Q0) from the PWM 3&4 duty cycle ratio (Q15)
    Tmp = (int)MPeriod*(int)p->MfuncC2;					// Q15 = Q0*Q15
    p->CMPA3 = (short)(Tmp>>16) + (short)(MPeriod>>1);	// Q0 = (Q15->Q0)/2 + (Q0/2)

// Compute the compare 5 (Q0) from the PWM 5&6 duty cycle ratio (Q15)
    Tmp = (int)MPeriod*(int)p->MfuncC3;					// Q15 = Q0*Q15
    p->CMPA5 = (short)(Tmp>>16) + (short)(MPeriod>>1);	// Q0 = (Q15->Q0)/2 + (Q0/2)

// Compute the opposite PWM compare's (rising Edge)
	if(p->CMPA1<0) p->CMPA1=0;
	if(p->CMPA1>MPeriod) p->CMPA1=MPeriod;
	if(p->CMPA3<0) p->CMPA3=0;
	if(p->CMPA3>MPeriod) p->CMPA3=MPeriod;
	if(p->CMPA5<0) p->CMPA5=0;
	if(p->CMPA5>MPeriod) p->CMPA5=MPeriod;
	p->CMPD1 = p->PeriodMax - p->CMPA1;
	p->CMPD3 = p->PeriodMax - p->CMPA3;
	p->CMPD5 = p->PeriodMax - p->CMPA5;
}

//===========================================================================
// No more.
//===========================================================================
