/** @file notification.c 
*   @brief User Notification Definition File
*   @date 25.July.2013
*   @version 03.06.00
*
*   This file  defines  empty  notification  routines to avoid
*   linker errors, Driver expects user to define the notification. 
*   The user needs to either remove this file and use their custom 
*   notification function or place their code sequence in this file 
*   between the provided USER CODE BEGIN and USER CODE END.
*
*/

/* Include Files */

#include "esm.h"
#include "sys_selftest.h"
#include "gio.h"
#include "het.h"
#include "rti.h"
#include "sys_dma.h"
/* USER CODE BEGIN (0) */
#include "IQmathLib.h"
#include "pwm.h"
#include "qep.h"
#include "rampgen.h"
#include "ipark.h"
#include "svgen.h"
/* USER CODE END */
#pragma WEAK(esmGroup1Notification)
void esmGroup1Notification(uint32 channel)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (1) */
/* USER CODE END */
}

/* USER CODE BEGIN (2) */
/* USER CODE END */
#pragma WEAK(esmGroup2Notification)
void esmGroup2Notification(uint32 channel)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (3) */
/* USER CODE END */
}

/* USER CODE BEGIN (4) */
/* USER CODE END */
#pragma WEAK(memoryPort0TestFailNotification)
void memoryPort0TestFailNotification(uint32 groupSelect, uint32 dataSelect, uint32 address, uint32 data)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (5) */
/* USER CODE END */
}

/* USER CODE BEGIN (6) */
/* USER CODE END */
#pragma WEAK(memoryPort1TestFailNotification)
void memoryPort1TestFailNotification(uint32 groupSelect, uint32 dataSelect, uint32 address, uint32 data)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (7) */
/* USER CODE END */
}

/* USER CODE BEGIN (8) */
/* USER CODE END */
#pragma WEAK(rtiNotification)
void rtiNotification(uint32 notification)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (9) */
	static int count = 0;
	static int index_cnt = QEP_MAX / 2;
	/*
	 * QEP emulation setup
	 * QEPA: GIOB[0] <----> HET1[24]
	 * QEPB: GIOB[6] <----> HET1[13]
	 * QEPI: GIOB[4] <----> HET1[15]
	 */
	count ++;
	index_cnt ++;
	switch(count)
	{
	case 1:
		gioPORTB->DSET = (1 << 0);
		gioPORTB->DCLR = (1 << 6);
		break;
	case 2:
		gioPORTB->DSET = (1 << 0);
		gioPORTB->DSET = (1 << 6);
		break;
	case 3:
		gioPORTB->DCLR = (1 << 0);
		gioPORTB->DSET = (1 << 6);
		break;
	case 4:
		gioPORTB->DCLR = (1 << 0);
		gioPORTB->DCLR = (1 << 6);
		count = 0;
		break;
	default:
		break;
	}
	if(index_cnt == QEP_MAX +1)
	{
		gioPORTB->DSET = (1 << 4);
		index_cnt = 0;
	}
	else if(index_cnt == 1)
	{
		gioPORTB->DCLR = (1 << 4);
	}
/* USER CODE END */
}

/* USER CODE BEGIN (10) */
/* USER CODE END */
#pragma WEAK(gioNotification)
void gioNotification(gioPORT_t *port, sint32 bit)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (19) */
/* USER CODE END */
}

/* USER CODE BEGIN (20) */
/* USER CODE END */


#pragma WEAK(pwmNotification)
void pwmNotification(hetBASE_t * hetREG,uint32 pwm, uint32 notification)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (35) */
/* USER CODE END */
}

/* USER CODE BEGIN (36) */
/* USER CODE END */
#pragma WEAK(edgeNotification)
void edgeNotification(hetBASE_t * hetREG,uint32 edge)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (37) */
/* USER CODE END */
}

/* USER CODE BEGIN (38) */
/* USER CODE END */
#pragma WEAK(hetNotification)
void hetNotification(hetBASE_t *het, uint32 offset)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (39) */
	#define PI		3.1415926
	static RAMPGEN rg1 = RAMPGEN_DEFAULTS;
	static IPARK ipark1 = IPARK_DEFAULTS;
	static SVGEN svgen1 = SVGEN_DEFAULTS;

	int deadzone = 1000;	//1000ns

	rg1.StepAngleMax = _IQ(BASE_FREQ*T);
	rg1.Freq = _IQ(0.2);
	RG_MACRO(rg1);

	ipark1.Ds = _IQ(0.6);
	ipark1.Qs = _IQ(0.0);
	ipark1.Sine = sin(rg1.Out * 2 * PI);
	ipark1.Cosine = cos(rg1.Out * 2 * PI);
	IPARK_MACRO(ipark1);

	svgen1.Ualpha = ipark1.Alpha;
	svgen1.Ubeta = ipark1.Beta;
	SVGENDQ_MACRO(svgen1);

	het_pwm_update(svgen1.Ta,svgen1.Tb,svgen1.Tc ,deadzone);

/* USER CODE END */
}

/* USER CODE BEGIN (40) */
/* USER CODE END */


/* USER CODE BEGIN (43) */
/* USER CODE END */


/* USER CODE BEGIN (47) */
/* USER CODE END */


/* USER CODE BEGIN (50) */
/* USER CODE END */


/* USER CODE BEGIN (53) */
/* USER CODE END */

#pragma WEAK(dmaGroupANotification)
void dmaGroupANotification(dmaInterrupt_t inttype, sint32 channel)
{
/*  enter user code between the USER CODE BEGIN and USER CODE END. */
/* USER CODE BEGIN (54) */
/* USER CODE END */
}
/* USER CODE BEGIN (55) */
/* USER CODE END */


/* USER CODE BEGIN (56) */
/* USER CODE END */
