/** @file sys_main.c 
*   @brief Application main file
*   @date 25.July.2013
*   @version 03.06.00
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* (c) Texas Instruments 2009-2013, All rights reserved. */

/* USER CODE BEGIN (0) */
/*
 * QEP emulation setup
 * QEPA: GIOB[0] <----> HET1[24]
 * QEPB: GIOB[6] <----> HET1[13]
 * QEPI: GIOB[4] <----> HET1[15]
 */
/* USER CODE END */

/* Include Files */

#include "sys_common.h"
#include "system.h"

/* USER CODE BEGIN (1) */
#include "het.h"
#include "rti.h"
#include "gio.h"
#include "qep.h"
#include "pwm.h"
/* USER CODE END */

/** @fn void main(void)
*   @brief Application main function
*   @note This function is empty by default.
*
*   This function is called after startup.
*   The user can use this function to implement the application.
*/

/* USER CODE BEGIN (2) */
int QEP_count;
/* USER CODE END */

void main(void)
{
/* USER CODE BEGIN (3) */
	hetInit();
	rtiInit();
	gioInit();

	// rti interrupt 0 used for emulator QEP encoder signal
	rtiStartCounter(rtiCOUNTER_BLOCK0);
	rtiEnableNotification(rtiNOTIFICATION_COMPARE0);
	// het interrupt used for generate SVPWM
	het_int_enable();

	_enable_interrupts();

	while(1)
	{
		QEP_count = ReadEncoder();
	}
/* USER CODE END */
}

/* USER CODE BEGIN (4) */
/* USER CODE END */
